#ifndef _IPEXTRA_H
#define _IPEXTRA_H

#include <asm/byteorder.h>
#include <net/if.h>

// maximum 40 bytes
// alignment: size of IP option fields as multiple of 4
struct ipopt {
#if defined(__LITTLE_ENDIAN_BITFIELD)
  __u8 number:5, class:2, flag:1;
#elif defined (__BIG_ENDIAN_BITFIELD)
  __u8 flag:1, class:2, number:5;
#else
#error "Please fix <asm/byteorder.h>"
#endif
  __u8 optlen;
  __u8 data[38];
};

#define IPOPT_HDRLEN ((int) &(((struct ipopt *)0)->data))

unsigned short ipextra_checksum(unsigned char* buf, int len);
void ipextra_add_option(char *src, int datalen, struct ipopt *opt, int optlen);
void ipextra_add_option2(char *dest, const char *src, int datalen, struct ipopt *opt,
                         int optlen);
void ipextra_del_option(char *src, int datalen, int optlen);
void ipextra_del_option2(char *dest, const char *src, int datalen, int optlen);

int ipextra_getifaddr(char *ifname, struct ifreq *ifr);

#endif /* _IPEXTRA_H */
