#ifndef _RAWSOCK_H
#define _RAWSOCK_H

/*
 * generic raw socket interface
 */

#include <arpa/inet.h>
#include <linux/ip.h>
#include <lib/net/ipextra.h>

typedef struct {
  int sd;
  __u8 ipproto;
  struct in_addr src_addr;
  struct in_addr dst_addr;
  struct sockaddr_in sockaddr;
  struct iphdr iph;          // normal 20-byte header
  struct ipopt opt;          // max 40-byte option
  unsigned char *data;
  int data_len;
} rawsock_t;

int rawsock_create_socket(rawsock_t *raw, __u8 ipproto);
void rawsock_close_socket(rawsock_t *raw);
void rawsock_fill_info(rawsock_t *raw);
void *rawsock_alloc_data(rawsock_t *raw, int data_len);
void rawsock_free_data(rawsock_t *raw);
int rawsock_send(rawsock_t *raw);
int rawsock_recv(rawsock_t *raw);

#endif /* _RAWSOCK_H */
