#ifndef _SSMSG_H
#define _SSMSG_H

inline __u8 ssmsg_msgtype(struct iphdr *iph, struct snapshot_opt *opt);

void ssmsg_dump_iphdr(struct iphdr *iph);
void ssmsg_dump_opt(struct snapshot_opt *opt);
void ssmsg_dump_vmap(unsigned char *data, int datalen);
void ssmsg_dump_rmap(unsigned char *data, int datalen);
void ssmsg_dump_smap(unsigned char *data, int datalen);
void ssmsg_dump_snapshot(unsigned char *data, int datalen);
void ssmsg_dump_stat(unsigned char *data, int datalen);
void ssmsg_dump_msg(struct snapshot_opt *opt, unsigned char *data,
                    int datalen);

int ssmsg_send_msg(__u32 localaddr, __u32 remoteaddr, __u8 msgtype,
                   __u32 seqno, unsigned char *data, int data_len);
int ssmsg_send_vmap(__u32 localaddr, __u32 remoteaddr, __u16 snapshotcnt,
                    __u32 *ssdata, int ssdata_cnt);
int ssmsg_send_rmap(__u32 localaddr, __u32 remoteaddr, __u8 connected,
                    __u32 *ssdata, int ssdata_cnt);
int ssmsg_send_smap(__u32 localaddr, __u32 remoteaddr, __u32 *ssdata,
                    int ssdata_cnt);
int ssmsg_send_reset(__u32 localaddr, __u32 remoteaddr);
int ssmsg_send_clear(__u32 localaddr, __u32 remoteaddr);
int ssmsg_send_control(__u32 localaddr, __u32 remoteaddr, __u32 seqno);
int ssmsg_send_marker(__u32 localaddr, __u32 remoteaddr, __u32 seqno);
int ssmsg_send_snapshot(__u32 localaddr, __u32 remoteaddr, __u32 seqno,
                        __u32 *ssdata, int ssdata_cnt);

#endif /* _SSMSG_H */
