#ifndef _SSPROC_H
#define _SSPROC_H

#include <pthread.h>
#include <sys/time.h>

#define SSPROC_STATE_UNINITIALIZED  0
#define SSPROC_STATE_READY          1
#define SSPROC_STATE_STARTED        2
#define SSPROC_STATE_FINISHED       3

typedef struct {
  int cnt;
  __u32 *addr;
} addrlist_t;

typedef struct {
  pthread_t recv_thread;
  pthread_mutex_t mutex;
  int state;
  ssnode_map_t map;
  addrlist_t nodes;  // address list of nodes 
  addrlist_t *links; // array of address list of each link
  int map_unack_cnt;
  __u32 seqno;
  struct timeval tv;
} ssproc_t;

#define ssproc_lock() pthread_mutex_lock(&(ssproc.mutex))
#define ssproc_unlock() pthread_mutex_unlock(&(ssproc.mutex))

#endif /* _SSPROC_H */
