#include <ctype.h>
#include <stdio.h>
#include <lib/util.h>

static inline void
__line_dump_hex(unsigned char *buf, int size)
{
  int i;
  for (i=0; i<16; i++) {
    if (i<size)
      printf("%02x ", buf[i]);
    else 
      printf("   ");
  }
}

static inline void
__line_dump_asc(unsigned char *buf, int size)
{
  int i;
  for (i=0; i<16; i++) {
    if (i<size) {
      printf("%c", isprint(buf[i]) ? buf[i] : '.');      
    } else {
      printf(" ");
    }
  }
}

void bufdump(void *buf, int size)
{
  int i;

  unsigned char *data = (unsigned char *) buf;
  for (i=0; i<size; i+=16) {
    printf("%c%04x:  ", ((i==0) ? '-' : ' '), i);
    __line_dump_hex(&(data[i]), min(16, (size-i)));
    printf("    ");
    __line_dump_asc(&(data[i]), min(16, (size-i)));
    printf("\n");
  }
}

inline int max(int a, int b) {
  return (a > b) ? a : b;
}

inline int min(int a, int b) {
  return (a < b) ? a : b;
}
