#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

inline void write_addr(FILE * fp, char *ip)
{
  in_addr_t in;

  in = inet_addr(ip);
  fwrite(&(in), sizeof(in), 1, fp);
}

inline FILE *open_file(char *name)
{
  FILE *fp;

  fp = fopen(name, "w+");
  if (fp == NULL)
    exit(1);

  return fp;
}

int main()
{
  FILE *fp;

  fp = open_file("nodes");
  write_addr(fp, "200.1.1.1");
  write_addr(fp, "200.1.2.2");
  write_addr(fp, "200.1.3.3");
  write_addr(fp, "200.1.4.4");
  write_addr(fp, "200.1.5.5");
  write_addr(fp, "200.1.6.6");
  write_addr(fp, "200.1.7.7");
  write_addr(fp, "200.1.8.8");
  write_addr(fp, "200.1.9.9");
  write_addr(fp, "200.1.10.10");
  write_addr(fp, "200.1.11.11");
  fclose(fp);

  fp = open_file("link0");
  write_addr(fp, "200.1.1.0");
  write_addr(fp, "200.1.1.1");
  write_addr(fp, "200.1.1.2");
  write_addr(fp, "255.255.255.255");
  fclose(fp);

  return 0;
}
