#include <router/ddos/traceback/traceback.h>

int main(int argc, char **argv)
{
  double mst;
  double markprob;
  double accuracy;
  double rate[500];
  int i, cnt;
  
  if (argc < 3) {
    printf("Usage: %s <marking probability> <accuracy> <local traffic rate(s)>\n",
           argv[0]);
    exit(1);
  }

  markprob = atof(argv[1]);
  accuracy = atof(argv[2]);

  printf("marking probability : %lf\n", markprob);
  printf("accuracy            : %lf\n", accuracy);
  
  cnt = argc - 3;  
  printf("number of routers   : %d\n", cnt);

  for (i=0; i<cnt; i++) {
    rate[i] = atof(argv[i+3]);
    printf("rate[%3d]           : %lf\n", i, rate[i]);
  }
  
  mst = calMinStableTime(markprob, accuracy, 13.0, cnt, rate);

  printf("\nminimum stable time :\n");
  printf("%lf\n", mst);

  return 0;
}
