#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <signal.h>
#include <arpa/inet.h>
#include <lib/util.h>
#include <math.h>

struct sockaddr_in cliAddr;
int cliAddrLen;
int servSd = -1;
unsigned int totalcount, count;
char buffer[1400];
int seqno;
int errcnt;

unsigned short port;
unsigned int addr;

/* initialize server socket */
static int init()
{
  struct sockaddr_in servAddr;
  int one = 1;

  servSd = socket(PF_INET, SOCK_DGRAM, 0);
  if (servSd < 0)
    ERR_RET(-1);

  setsockopt(servSd, SOL_SOCKET, SO_REUSEADDR, (char *) &one, sizeof(one));
  servAddr.sin_family = AF_INET;
  servAddr.sin_port = port;
  servAddr.sin_addr.s_addr = addr;
  if (bind(servSd, (struct sockaddr *) &servAddr, sizeof(servAddr)) < 0)
    ERR_RET(-1);

  return 0;
}

/* close server socket */
static inline void close_socket()
{
  if (servSd >= 0)
    close(servSd);
}


/* clean up process */
static void cleanup()
{
  close_socket();
}

/* signal handler */
static void signal_handler(int signo)
{
  exit(0);
}

/* catch signal */
static inline void catch_signal()
{
  signal(SIGINT, signal_handler);       // catch CTRL-C signal
  signal(SIGQUIT, signal_handler);      // catch CTRL-\ signal
}

/* clear signal */
static inline void clear_signal()
{
  signal(SIGINT, SIG_DFL);      // restore CTRL-C signal
  signal(SIGQUIT, SIG_DFL);     // restore CTRL-\ signal
}

/* exit handler */
static void exit_handler()
{
  printf("number of packet received = %d\n", count);
  printf("number of errors = %d\n", errcnt);
  cleanup();
}

/* main */
int main(int argc, char **argv)
{
  int ret;

  if (argc != 3) {
    printf("Usage: %s <host> <port>\n", argv[0]);
    exit(1);
  }

  addr = inet_addr(argv[1]);
  port = htons(atoi(argv[2]));

  atexit(&exit_handler);
  catch_signal();

  memset(buffer, 0x00, sizeof(buffer));

  count = 0;
  seqno = 0;
  errcnt = 0;

  if (init() == -1)
    exit(1);

  while (1) {
    cliAddrLen = sizeof(cliAddr);
    ret = recvfrom(servSd, buffer, sizeof(buffer), 0,
                   (struct sockaddr *) &cliAddr, &cliAddrLen);
    if (ret == -1)
      errcnt++;

    count++;

/*
    if (cliAddr.sin_addr.s_addr == addr) {
      count++;
    }
*/
  }

  cleanup();

  return 0;
}
